using System;
using System.Threading.Tasks;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.Pathing;
using Styx.Plugins;
using Bots.Grind;
using Buddy.Coroutines;
using CommonBehaviors.Actions;
using Styx.TreeSharp;

namespace AzyulDDSupport
{
	public class AzyulDDSupport : HBPlugin
	{
		public override string Name { get { return "Azyul Death Handler"; } }
		public override string Author { get { return "EchoTiger"; } }
		public override Version Version { get { return new Version(1, 0); } }
		public override bool WantButton { get { return false; } }

		public override void OnEnable()
		{
			TreeHooks.Instance.InsertHook("Questbot_Main", 0,
				_deathSupportComposite ?? (_deathSupportComposite = new ActionRunCoroutine(ctx => UniversalDeathSupport())));
				
			Logging.Write(System.Windows.Media.Colors.Yellow, "[Azyul Death Handler]: v" + Version + " - Enabled");
		}

		public override void OnDisable()
		{
			TreeHooks.Instance.RemoveHook("Questbot_Main", _deathSupportComposite);
		  
			Logging.Write(System.Windows.Media.Colors.Yellow, "[Azyul Death Handler]: v" + Version + " - Disabled");
		}
		
		private Composite _deathSupportComposite;

		private async Task<bool> UniversalDeathSupport()
		{
			if (!StyxWoW.Me.IsGhost)
				return false;

			if (StyxWoW.Me.CorpseMapId == StyxWoW.Me.MapId)
				return false;

			while (StyxWoW.Me.IsValid && StyxWoW.Me.IsGhost)
			{
				if (StyxWoW.Me.Location.DistanceSqr(StyxWoW.Me.CorpsePoint) > 5f*5f)
				{
				  //Flightor handles calling Navigator internally when it can't fly.
					Flightor.MoveTo(StyxWoW.Me.CorpsePoint);
				}
				else
				{
					StyxWoW.Me.SetFacing(StyxWoW.Me.CorpsePoint);
					// Wait until we face the dungeon entrance. No need to spam face
					await Coroutine.Wait(5000, () => StyxWoW.Me.IsFacing(StyxWoW.Me.CorpsePoint));
					Navigator.PlayerMover.MoveTowards(StyxWoW.Me.CorpsePoint);
				}
				await Coroutine.Yield();
			}

			return true;
		}

		public override void Pulse()
		{
		}
	}
}